<?php
@set_time_limit(0);

include('../inc/config.php');
include('../../inc/config.settings.php');
include('../../inc/common.php');
include('../../inc/header.php');
include('../../inc/class.session.php');
include('../../inc/dbhandle.php');

if ($allow_webadmin == false) {
	echo 'You are not allowed to access';
	exit;
}

$retid = (double)microtime()*100000000;
$sessid = get_val('sessid');

if (!preg_match('/^[0-9a-z]{40}$/i', $sessid)) {
	Header('Location: index.php?retid='.$retid); 
	exit; 
}

define('WM_ADMIN_LOGINED', true);

$sesshandle = New Session();
$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
$sesshandle->sessid = $sessid;
$sesshandle->timeout = $session_timeout;
$sesshandle->enable_cookies = true;
$sesshandle->enable_ipcheck = $enable_ipcheck;
$sesshandle->sesstype = SESSION_ADMIN;
if (defined('OPEN_ADMIN_API')) {
	$sesshandle->enable_cookies = false;
	$sesshandle->enable_ipcheck = false;
}

$session_value = $sesshandle->Load();
if ($session_value === false){
	Header('Location: error.php?&err=1&retid='.$retid); 
	exit; 
}

if ($session_value['admin_auth'] && $session_value['session'] != '' && $session_value['adminuser'] != '' 
	&& in_array($session_value['admintype'], array('supper', 'domain', 'role'))) {
	$nowstamp = time();
	if (intval($nowstamp - $session_value['admin_start']) > $session_timeout) {
		Header('Location: error.php?sessid='.$sessid.'&err=2&retid='.$retid); 
		exit; 
	}
	
	$session_value['admin_start'] = $nowstamp;
	$sesshandle->Save($session_value);
}
else{
	Header('Location: error.php?sessid='.$sessid.'&retid='.$retid);
	exit;
}

extract($_GET, EXTR_SKIP);
extract($_POST, EXTR_SKIP);

$lid = $session_value['lid'];
$pag = intval($pag);

include('../inc/global.php');
include('../inc/smarty.php');
include('../inc/lib.php');

$smarty->assign('AllowSMS', $sms_function);

$smarty->assign('SessID', $sessid);
$smarty->assign('Dest', $dest);
$smarty->assign('RetID', $retid);

$smarty->assign('AdminUser', $session_value['adminuser']);
$smarty->assign('AdminType', $session_value['admintype']);
$smarty->assign('AdminRight', $session_value['adminright']);
$smarty->assign('VersionType', $session_value['versiontype']);
$smarty->assign('IsLinux', (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') ? false : true);

if ($session_value['admintype'] == 'supper') {
	$smarty->assign('PatchVersion', $session_value['patchversion']);
	$smarty->assign('NewVersion', $session_value['newversion']);
	$smarty->assign('VisitUrl', $session_value['visiturl']);
}

switch(strtolower($dest)){
case 'login':
	if ($session_value['admintype'] == 'supper' && $session_value['initalize'])
		$display_page = $selected_theme.'/initialize.htm';
	else
		$display_page = $selected_theme.'/main.htm';
	break;
case 'initialize':
	include('../operation/initialize.php');
	break;
default:
case 'mainpage':
	include('../operation/mainpage.php');
	break;
case 'mailmonitor':
	include('../operation/mailmonitor.php');
	break;
case 'mailsign':
	include('../operation/mailsign.php');
	break;
case 'publicfolder':
	include('../operation/publicfolder.php');
	break;
case 'user':
	include('../operation/user.php');
	break;
case 'group':
	include('../operation/group.php');
	break;
case 'useralias':
	include('../operation/useralias.php');
	break;
case 'domain':
	include('../operation/domain.php');
	break;
case 'domainalias':
	include('../operation/domainalias.php');
	break;
case 'adminuser':
	include('../operation/adminuser.php');
	break;
case 'chgpwd':
	include('../operation/chgpwd.php');
	break;
}

if ($display_page != '')
	$smarty->display($display_page);
?>